{% extends 'base.html.twig' %}

{% block title %} louer un bien {% endblock %}

{% block body %}
    <div class="container">
        <div class="row">
            <div class="col-md-3">&nbsp;</div>
            <h1>Louer le bien{{bien.titre}}</h1>
            <pre>
                {{ dump(prix) }}
            </pre>
            <div class="col-md-6">
                <div class="bg-dark py-3 px-3 ">
                <div>

                {{

                    bien.price 
                }}
                </div>

                {{ form_start(form)}}
                <label>
                    Nombre d'adultes
                    <input class="calcul" type="number" id="nb_adulte">
                </label>
                <label>
                    Nombre d'enfants
                    <input class="calcul" type="number" id="nb_enfant">
                </label>

                {{ form_widget(form) }}
                <h4>
                    <div class="row-cols-4" id="price_frame"></div>
                </h4>
                <button type="submit" class="btn btn-primary">Reserver </button>
                {{ form_end(form) }}


                </div>
            </div>
        </div>
    
    </div>

{% endblock %}

{% block javascripts %}
<script>

$(function(){
    /**
    **
    **       GESTION DES DATES DU CALANDRIER 
    **
    */
    let oldReservation = {{oldReservation}};
    let toDay= new Date();
    let thisMonth = toDay.getMonth();
    let thisDay = toDay.getDate();
    let thisYear = toDay.getFullYear();
   /* amenagement du calandrier DES MOIS avec JQUERY*/
    for(let i=0; i<4; i++){
        let option2Deselect = '#reservation_date_debut_date_month option:last';

        if(i < 2 ){
            $(option2Deselect).remove(); 
        }
        let optionDeselect = '#reservation_date_debut_date_month option:first';
        $(optionDeselect).remove();
        let option_2Deselect = '#reservation_date_fin_date_month option:last';

        if(i < 2 ){
            $(option_2Deselect).remove(); 
        }
        let option_Deselect = '#reservation_date_fin_date_month option:first';
        $(option_Deselect).remove();

    }
    let tab = ['mai','juin','juillet','aout','septembre', 'octobre'];
    for(let i= 0; i<6; i++){
        $ourMonth= i+3;
        let monthToChange = '#reservation_date_debut_date_month option:eq('+i+')';
        let month2ToChange = '#reservation_date_fin_date_month option:eq('+i+')';
        if($ourMonth = thisMonth && !oldReservation){
            $(monthToChange).prop('selected', true);
            $(month2ToChange).prop('selected', true);
 
        }
        $(monthToChange).html(tab[i]);
        $(month2ToChange).html(tab[i]);
    }
    if(!oldReservation ){
    /*Amenagement Jour */
        $('#reservation_date_debut_date_day option[value="'+thisDay+'"]').prop('selected', true);
        $('#reservation_date_fin_date_day option[value="'+thisDay+'"]').prop('selected', true);


        /* heures */
        $('#reservation_date_debut_time_hour option[value="12"]').prop('selected', true);
        $('#reservation_date_fin_time_hour option[value="12"]').prop('selected', true);


    }
    //SUpression des heures impossibles.
    for(let i = 0; i<25; i++){
        $heureDebut= $('#reservation_date_debut_time_hour option[value="'+i+'"]');
        $heurefin= $('#reservation_date_fin_time_hour option[value="'+i+'"]');

        if(i <7 || i>22){
            $heureDebut.remove();
            $heurefin.remove();
        }


    }
    /*année*/
    $allYears = $('#reservation_date_debut_date_year option');
    $thisYearoption= $('#reservation_date_debut_date_year option[value="'+thisYear+'"]');
    $thisYearoption2= $('#reservation_date_debut_date_year option[value="'+(thisYear+1)+'"]');

    $selectYear = $('#reservation_date_debut_date_year');
    $allYears.remove();
    $selectYear.append($thisYearoption);
    $selectYear.append($thisYearoption2);
    if(!oldReservation ){

        $thisYearoption.prop('selected', true);
    }

    $allYears = $('#reservation_date_fin_date_year option');
    $thisYearoption= $('#reservation_date_fin_date_year option[value="'+thisYear+'"]');
    $thisYearoption2= $('#reservation_date_fin_date_year option[value="'+(thisYear+1)+'"]');

    $selectYear = $('#reservation_date_fin_date_year');
    $allYears.remove();

    $selectYear.append($thisYearoption);
    $selectYear.append($thisYearoption2);
    if(!oldReservation ){
        
        $thisYearoption.prop('selected', true);
    }

    // CALCULER LE NB DE PERSONNES :
    date_d = getInputDate('debut');
    date_f = getInputDate('fin');

    nbJour = date_f - date_d;
    if(nbJour<0) nbJour = 0;
    nbJour = nbJour/1000/60/60/24;
    JoursAdulte= $('#reservation_famille_jours_adultes').val();
    JoursEnfant = $('#reservation_famille_jours_enfants').val();
    nbAdulte = Math.round(JoursAdulte/nbJour);
    nbEnfant = Math.round(JoursEnfant/nbJour);
    if(nbAdulte>25)nbAdulte = 0;
    if(nbEnfant>25)nbEnfant = 0;

    $('#nb_adulte').val(nbAdulte);
    $('#nb_enfant').val(nbEnfant);
    $('').trigger('click');
    function getInputDate(target){
            mois_d = $('#reservation_date_'+target+'_date_month').val();
            jour_d = $('#reservation_date_'+target+'_date_day').val();
            annee_d = $('#reservation_date_'+target+'_date_year').val();
            heure_d = $('#reservation_date_'+target+'_time_hour').val();
            minute_d = $('#reservation_date_'+target+'_time_minute').val();
            
            let date_d = new Date();
            date_d.setMonth((mois_d-1));
            date_d.setDate(jour_d);
            date_d.setFullYear(annee_d);
            date_d.setHours(heure_d);
            date_d.setMinutes(minute_d);
            return date_d;

    }
    /*operation de calcul nb jours par personne*/
    //attribuer class calcul a tout champ qui le lancent

    $('[class="calcul"], [class="form-control"]').click(function(){

        let begin = $(this).hasClass('nocalcul');
        if(!begin){

            
            let date_d = getInputDate('debut');
            
            let date_f = getInputDate('fin');

            // SI DATE FIN < DATE DEBUT:
            //  Date fin = date debut + 7 
            function changeDate(target, date){
                month= date.getMonth()+1;
                mois_new = $('#reservation_date_'+target+'_date_month option[value="'+month+'"]').prop('selected',true);
                jour_new = $('#reservation_date_'+target+'_date_day option[value="'+date.getDate()+'"]').prop('selected',true);
                annee_new = $('#reservation_date_'+target+'_date_year option[value="'+date.getFullYear()+'"]').prop('selected',true);
                heure_new = $('#reservation_date_'+target+'_time_hour option[value="'+date.getHours()+'"]').prop('selected',true);
                minute_new = $('#reservation_date_'+target+'_time_minute option[value="'+date.getMinutes()+'"]').prop('selected',true);
            }
            if(date_f< date_d){
                date_f= new Date(date_d.getTime());
                date_fin= date_f.setDate(date_f.getDate()+ 7);
                changeDate('fin', date_f);


            }

            // TEMPS PASSÉ AU CAMPING 

            let nbMillisecondes = date_f - date_d;
            const nbJours = nbMillisecondes/1000/60/60/24;



            // NB ADULTES/ENFANT
            let nbAdulte = $('#nb_adulte').val();
            let nbEnfant = $('#nb_enfant').val();



            /*
            **  **  **  **  **  **  **  **  **  **  **  **  **  
            **                                              **
            **             PARTIE II : LE CALCUL DU PRIX    **
            **                                              **
            **  **  **  **  **  **  **  **  **  **  **  **  **
            */
            // CALCUL AUTOMATIQUE NB JOUR ADULTE ENFANT

            let JoursAdulte = $('#reservation_famille_jours_adultes').val(Math.round(nbJours*nbAdulte));
            JoursAdulte= $('#reservation_famille_jours_adultes').val();
            let JoursEnfant = $('#reservation_famille_jours_enfants').val(Math.round(nbJours*nbEnfant));
            JoursEnfant = $('#reservation_famille_jours_enfants').val();

            let JoursAdultePiscine = $('#reservation_famille_jours_piscine_adultes').val(Math.round(nbJours*nbAdulte));
            JoursAdultePiscine = $('#reservation_famille_jours_piscine_adultes').val();

            let JoursEnfantPiscine = $('#reservation_famille_jours_piscine_enfants').val(Math.round(nbJours*nbEnfant));
            JoursEnfantPiscine = $('#reservation_famille_jours_piscine_enfants').val();

            total = 0;
            console.log(" DEBUT");
            prixBien = {{bien.price}};
            console.log(prixBien);
            
            JoursPersonne  = JoursAdulte/nbAdulte;
            total= doFactureForSeason(date_d,date_f, prixBien,JoursPersonne );
            10
           
            taxeAdulte = (0.6*JoursAdulte);
            console.log( " taxe adulte : "+taxeAdulte+" pour "+JoursAdulte+" jours adultes; "+nbAdulte+" personnes ");
            total += taxeAdulte;
            taxeEnfant = (0.35*JoursEnfant);
            console.log( " taxe enfant : "+taxeEnfant+" pour "+JoursEnfant+" jours enfants; "+nbEnfant+" personnes ");

            total += taxeEnfant;
            taxePiscineAdulte = (1.5*JoursAdultePiscine);
            console.log( " Piscine adulte : "+taxePiscineAdulte+" pour "+JoursAdultePiscine+" jours piscine adulte; "+nbAdulte+" personnes ");


            total += taxePiscineAdulte;
            taxePiscineEnfant = (1.0*JoursEnfantPiscine);
            console.log( " Piscine enfant : "+taxePiscineEnfant+" pour "+JoursEnfantPiscine+" jours piscine enfants; "+nbEnfant+" personnes ");
            total += taxePiscineEnfant;
            console.log(" TOTAL FINAL = "+total);

            // INCLURE LE TOTAL SUR LA PAGE 
            $('#price_frame').html('prix total : '+total+'€');



            /*
                FONCTION DE CALCUL DU PRIX:

                1 Facture():
                    calcule pour 1e personne
                2 New Facture():
                    calcule lorsqu'il y a chevauchement
                3 DoFactureForSeason():
                    calcule si selon les inputs dates,
                    on utilise la premiere ou la seconde.
            
            */
            // FACTURE CALCULE LES Rabais:
            function facture(nbJour, prixloc){
                console.log(" fonction de calcul Simple");

                tableau_dump = [];
                //TEST REMISES
                nbSemaine= Math.floor(nbJour/7);
                jrRestant = nbJour%7;
                prixSemaine = (7*prixloc);
                prixt= 0;
                iteration = 0;
                if(nbSemaine>=1){
                    for(let i=0 ; nbSemaine >= i ; nbSemaine--){
                        //derniere Semaine: nb Jours particulier
                        if(i == nbSemaine){

                            prixt += (prixSemaine/7)*jrRestant;
                            console.log("iteration n°"+iteration+" calcul de "+jrRestant+" jours Restant ; prix jour("+(prixSemaine/7)+") = "+prixloc+" - remiseJour("+(remise/7)+") ; total jour restant = "+((prixSemaine/7)*jrRestant)  );

                        }else{
                            prixt += prixSemaine;

                        }
                        remise  = prixSemaine*0.05;
                        prixSemaine -= remise;
                        console.log(" iteration n°"+iteration+"cout de la semaine ; prix semaine("+ (7*prixloc)+")- remise("+remise+") = "+prixSemaine );
                        iteration += 1;                         
                    } 
                    console.log(" FIN Explication total : "+nbSemaine+" semaine ; "+jrRestant+" jours; prix jour = "+prixloc+" ; prix total sans taxe: "+prixt+" ;" );
   
                }else{
                    prixt += prixloc *jrRestant;
                    console.log(" FIN Explication total : 0 semaine ; "+jrRestant+" jours; prix jour = "+prixloc+" ; prix total sans taxe: "+prixt+" ;" );


                }
                return prixt;
            }
     
            
            function Newfacture(j_avant,j_pendant, j_apres, prixloc){
               tout_j = j_avant+j_pendant+ j_apres;
               prixT = 0;
               taux = 0.05;
               tauxAplique = 0;
               rabais = 0;
               jCount = 0;
               prixNormal= prixloc;
               nbSemaine =  Math.floor(tout_j/7);
               semaineCount = 0;
               for(i= 0; i< tout_j; i++){
                   //PRIX DE LOC SELON LA SAISON
                    if(i< j_avant){
                        prixloc = prixNormal;
                    }else if(i< (j_avant+j_pendant)){
                        prixloc = prixNormal+(prixNormal * 0.15);

                    }else if( i< (j_avant+j_pendant+j_apres)){
                        prixloc = prixNormal;

                    }
                    
                    // CALCUL RABAIS:
                    /*
                        Chaque jour jCount + 1, au bout d'une semaine
                        > le 5% de remise est appliqué une fois de plus
                        sur le jour
                    */
                    for(j=0; j<tauxAplique; j++){
                        rabais+= (prixloc*taux);
                    }
                        remiseSemaine = rabais *7;
                       prixT += prixloc-rabais;
                    rabais = 0;
                    jCount += 1;
                    if(jCount == 7){
                        console.log(" semaine n°"+semaineCount+" cout de la semaine : prix semaine("+ (7*prixloc)+")- remise("+remiseSemaine+") = "+( (7*prixloc)-remiseSemaine));
                        semaineCount += 1;
                    tauxAplique+=1;
                    jCount = 0;
                    }
                }
                console.log(" FIN explication total : "+( nbSemaine )+" semaine ;"+(tout_j % 7) +" jours;  ");
                return prixT;
            }

            function doFactureForSeason(date_d, date_f, prixlocation, nbjours){
                //debut de saison:
                haute_d = new Date();
                haute_d.setFullYear(date_d.getFullYear());
                haute_d.setDate(20);
                haute_d.setMonth(05);
                //fin de saison:
                haute_f = new Date();
                haute_f.setFullYear(date_d.getFullYear());
                haute_f.setDate(31);
                haute_f.setMonth(07);


                //Si seulement Basse Saison 
                if(date_f<haute_d){

                    total = facture(nbjours,prixlocation);
                }else if(date_d> haute_f){


                    total = facture(nbjours,prixlocation);

                }else if ( date_d>haute_d && date_f < haute_f){

                    // si seulement Haute saison
                    prixlocation += prixlocation* 0.15;
                    total = facture(nbjours,prixlocation);

                }
                if(date_d< haute_d && date_f > haute_d || date_d< haute_f && date_f > haute_f){
                    console.log(" fonction de calcul Jour sur deux saisons");
                    //CONAITRE NB JOUR POUR CHAQUE SAISON 
                    j_avant= haute_d-date_d;
                    if(j_avant>0){
                        j_avant = j_avant/1000/60/60/24;
                    }else{
                        j_avant = 0;
                    }

                    j_apres = date_f- haute_f;
                    if(j_apres>0){
                        j_apres = j_apres/1000/60/60/24;
                    }else{
                        j_apres = 0;
                    }

                    j_pendant = date_f- date_d;
                    j_pendant = j_pendant/1000/60/60/24;
                    j_pendant= j_pendant -(j_apres + j_avant);



                    console.log(" jours avant haute saison :"+j_avant+" ; jours haute saison : "+j_pendant+" ; jours aprés haute saison : "+ j_apres);
                    total= Newfacture(j_avant, j_pendant, j_apres, prixlocation);

                }
                return total;
            }




        }
    });



});  
    
    


</script>
{% endblock %}

